/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /builddir/build/BUILD/thunderbird-3.0.5/comm-1.9.1/mailnews/addrbook/public/nsIAbLDAPDirectory.idl
 */

#ifndef __gen_nsIAbLDAPDirectory_h__
#define __gen_nsIAbLDAPDirectory_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIMutableArray; /* forward declaration */

class nsILocalFile; /* forward declaration */

class nsIAddrDatabase; /* forward declaration */

class nsIAbLDAPAttributeMap; /* forward declaration */

class nsILDAPURL; /* forward declaration */

#define kLDAPDirectoryRoot         "moz-abldapdirectory://"
#define kLDAPDirectoryRootLen      22

/* starting interface:    nsIAbLDAPDirectory */
#define NS_IABLDAPDIRECTORY_IID_STR "90dde295-e354-4d58-add8-f9b29a95942d"

#define NS_IABLDAPDIRECTORY_IID \
  {0x90dde295, 0xe354, 0x4d58, \
    { 0xad, 0xd8, 0xf9, 0xb2, 0x9a, 0x95, 0x94, 0x2d }}

/**
 * XXX This should really inherit from nsIAbDirectory, and some day it will.
 * But for now, doing that complicates implementation.
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIAbLDAPDirectory : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IABLDAPDIRECTORY_IID)

  /**
   * If set, these arrays of nsILDAPControls are passed through to the
   * nsILDAPOperation that searchExt is called on.
   */
  /* attribute nsIMutableArray searchServerControls; */
  NS_SCRIPTABLE NS_IMETHOD GetSearchServerControls(nsIMutableArray * *aSearchServerControls) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetSearchServerControls(nsIMutableArray * aSearchServerControls) = 0;

  /* attribute nsIMutableArray searchClientControls; */
  NS_SCRIPTABLE NS_IMETHOD GetSearchClientControls(nsIMutableArray * *aSearchClientControls) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetSearchClientControls(nsIMutableArray * aSearchClientControls) = 0;

  /**
   * The Replication File Name to use.
   */
  /* attribute ACString replicationFileName; */
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFileName(nsACString & aReplicationFileName) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetReplicationFileName(const nsACString & aReplicationFileName) = 0;

  /**
   * The version of LDAP protocol in use.
   */
  /* attribute unsigned long protocolVersion; */
  NS_SCRIPTABLE NS_IMETHOD GetProtocolVersion(PRUint32 *aProtocolVersion) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetProtocolVersion(PRUint32 aProtocolVersion) = 0;

  /**
   * The SASL mechanism to use to authenticate to the LDAP server
   * If this is an empty string, then a simple bind will be performed
   * A non-zero string is assumed to be the name of the SASL mechanism.
   * Currently the only supported mechanism is GSSAPI
   */
  /* attribute ACString saslMechanism; */
  NS_SCRIPTABLE NS_IMETHOD GetSaslMechanism(nsACString & aSaslMechanism) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetSaslMechanism(const nsACString & aSaslMechanism) = 0;

  /**
   * The AuthDN to use to access the server.
   */
  /* attribute AUTF8String authDn; */
  NS_SCRIPTABLE NS_IMETHOD GetAuthDn(nsACString & aAuthDn) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetAuthDn(const nsACString & aAuthDn) = 0;

  /**
   * The maximum number of matches that the server will return per a search.
   */
  /* attribute long maxHits; */
  NS_SCRIPTABLE NS_IMETHOD GetMaxHits(PRInt32 *aMaxHits) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetMaxHits(PRInt32 aMaxHits) = 0;

  /**
   * The Last Change Number used for replication.
   */
  /* attribute long lastChangeNumber; */
  NS_SCRIPTABLE NS_IMETHOD GetLastChangeNumber(PRInt32 *aLastChangeNumber) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetLastChangeNumber(PRInt32 aLastChangeNumber) = 0;

  /**
   * The LDAP server's scoping of the lastChangeNumber.
   */
  /* attribute ACString dataVersion; */
  NS_SCRIPTABLE NS_IMETHOD GetDataVersion(nsACString & aDataVersion) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetDataVersion(const nsACString & aDataVersion) = 0;

  /**
   * The attribute map that is associated with this directory's server.
   */
  /* readonly attribute nsIAbLDAPAttributeMap attributeMap; */
  NS_SCRIPTABLE NS_IMETHOD GetAttributeMap(nsIAbLDAPAttributeMap * *aAttributeMap) = 0;

  /**
   * The LDAP URL for this directory. Note that this differs from
   * nsIAbDirectory::URI. This attribute will give you a true ldap
   * url, e.g. ldap://localhost:389/ whereas the uri will give you the
   * directories rdf uri, e.g. moz-abldapdirectory://<pref base name>/.
   */
  /* attribute nsILDAPURL lDAPURL; */
  NS_SCRIPTABLE NS_IMETHOD GetLDAPURL(nsILDAPURL * *aLDAPURL) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetLDAPURL(nsILDAPURL * aLDAPURL) = 0;

  /**
   * The replication (offline) file that this database uses.
   */
  /* readonly attribute nsILocalFile replicationFile; */
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFile(nsILocalFile * *aReplicationFile) = 0;

  /**
   * A database that is set up for the replication file.
   */
  /* readonly attribute nsIAddrDatabase replicationDatabase; */
  NS_SCRIPTABLE NS_IMETHOD GetReplicationDatabase(nsIAddrDatabase * *aReplicationDatabase) = 0;

  /**
   * The LDAP attributes used to build the Relative Distinguished Name
   * of new cards, in the form of a comma separated list.
   *
   * The default is to use the common name (cn) attribute.
   */
  /* attribute ACString rdnAttributes; */
  NS_SCRIPTABLE NS_IMETHOD GetRdnAttributes(nsACString & aRdnAttributes) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetRdnAttributes(const nsACString & aRdnAttributes) = 0;

  /**
   * The LDAP objectClass values added to cards when they are created/added,
   * in the form of a comma separated list.
   *
   * The default is to use the following classes:
   * top,person,organizationalPerson,inetOrgPerson,mozillaAbPersonAlpha
   */
  /* attribute ACString objectClasses; */
  NS_SCRIPTABLE NS_IMETHOD GetObjectClasses(nsACString & aObjectClasses) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetObjectClasses(const nsACString & aObjectClasses) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIAbLDAPDirectory, NS_IABLDAPDIRECTORY_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIABLDAPDIRECTORY \
  NS_SCRIPTABLE NS_IMETHOD GetSearchServerControls(nsIMutableArray * *aSearchServerControls); \
  NS_SCRIPTABLE NS_IMETHOD SetSearchServerControls(nsIMutableArray * aSearchServerControls); \
  NS_SCRIPTABLE NS_IMETHOD GetSearchClientControls(nsIMutableArray * *aSearchClientControls); \
  NS_SCRIPTABLE NS_IMETHOD SetSearchClientControls(nsIMutableArray * aSearchClientControls); \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFileName(nsACString & aReplicationFileName); \
  NS_SCRIPTABLE NS_IMETHOD SetReplicationFileName(const nsACString & aReplicationFileName); \
  NS_SCRIPTABLE NS_IMETHOD GetProtocolVersion(PRUint32 *aProtocolVersion); \
  NS_SCRIPTABLE NS_IMETHOD SetProtocolVersion(PRUint32 aProtocolVersion); \
  NS_SCRIPTABLE NS_IMETHOD GetSaslMechanism(nsACString & aSaslMechanism); \
  NS_SCRIPTABLE NS_IMETHOD SetSaslMechanism(const nsACString & aSaslMechanism); \
  NS_SCRIPTABLE NS_IMETHOD GetAuthDn(nsACString & aAuthDn); \
  NS_SCRIPTABLE NS_IMETHOD SetAuthDn(const nsACString & aAuthDn); \
  NS_SCRIPTABLE NS_IMETHOD GetMaxHits(PRInt32 *aMaxHits); \
  NS_SCRIPTABLE NS_IMETHOD SetMaxHits(PRInt32 aMaxHits); \
  NS_SCRIPTABLE NS_IMETHOD GetLastChangeNumber(PRInt32 *aLastChangeNumber); \
  NS_SCRIPTABLE NS_IMETHOD SetLastChangeNumber(PRInt32 aLastChangeNumber); \
  NS_SCRIPTABLE NS_IMETHOD GetDataVersion(nsACString & aDataVersion); \
  NS_SCRIPTABLE NS_IMETHOD SetDataVersion(const nsACString & aDataVersion); \
  NS_SCRIPTABLE NS_IMETHOD GetAttributeMap(nsIAbLDAPAttributeMap * *aAttributeMap); \
  NS_SCRIPTABLE NS_IMETHOD GetLDAPURL(nsILDAPURL * *aLDAPURL); \
  NS_SCRIPTABLE NS_IMETHOD SetLDAPURL(nsILDAPURL * aLDAPURL); \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFile(nsILocalFile * *aReplicationFile); \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationDatabase(nsIAddrDatabase * *aReplicationDatabase); \
  NS_SCRIPTABLE NS_IMETHOD GetRdnAttributes(nsACString & aRdnAttributes); \
  NS_SCRIPTABLE NS_IMETHOD SetRdnAttributes(const nsACString & aRdnAttributes); \
  NS_SCRIPTABLE NS_IMETHOD GetObjectClasses(nsACString & aObjectClasses); \
  NS_SCRIPTABLE NS_IMETHOD SetObjectClasses(const nsACString & aObjectClasses); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIABLDAPDIRECTORY(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetSearchServerControls(nsIMutableArray * *aSearchServerControls) { return _to GetSearchServerControls(aSearchServerControls); } \
  NS_SCRIPTABLE NS_IMETHOD SetSearchServerControls(nsIMutableArray * aSearchServerControls) { return _to SetSearchServerControls(aSearchServerControls); } \
  NS_SCRIPTABLE NS_IMETHOD GetSearchClientControls(nsIMutableArray * *aSearchClientControls) { return _to GetSearchClientControls(aSearchClientControls); } \
  NS_SCRIPTABLE NS_IMETHOD SetSearchClientControls(nsIMutableArray * aSearchClientControls) { return _to SetSearchClientControls(aSearchClientControls); } \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFileName(nsACString & aReplicationFileName) { return _to GetReplicationFileName(aReplicationFileName); } \
  NS_SCRIPTABLE NS_IMETHOD SetReplicationFileName(const nsACString & aReplicationFileName) { return _to SetReplicationFileName(aReplicationFileName); } \
  NS_SCRIPTABLE NS_IMETHOD GetProtocolVersion(PRUint32 *aProtocolVersion) { return _to GetProtocolVersion(aProtocolVersion); } \
  NS_SCRIPTABLE NS_IMETHOD SetProtocolVersion(PRUint32 aProtocolVersion) { return _to SetProtocolVersion(aProtocolVersion); } \
  NS_SCRIPTABLE NS_IMETHOD GetSaslMechanism(nsACString & aSaslMechanism) { return _to GetSaslMechanism(aSaslMechanism); } \
  NS_SCRIPTABLE NS_IMETHOD SetSaslMechanism(const nsACString & aSaslMechanism) { return _to SetSaslMechanism(aSaslMechanism); } \
  NS_SCRIPTABLE NS_IMETHOD GetAuthDn(nsACString & aAuthDn) { return _to GetAuthDn(aAuthDn); } \
  NS_SCRIPTABLE NS_IMETHOD SetAuthDn(const nsACString & aAuthDn) { return _to SetAuthDn(aAuthDn); } \
  NS_SCRIPTABLE NS_IMETHOD GetMaxHits(PRInt32 *aMaxHits) { return _to GetMaxHits(aMaxHits); } \
  NS_SCRIPTABLE NS_IMETHOD SetMaxHits(PRInt32 aMaxHits) { return _to SetMaxHits(aMaxHits); } \
  NS_SCRIPTABLE NS_IMETHOD GetLastChangeNumber(PRInt32 *aLastChangeNumber) { return _to GetLastChangeNumber(aLastChangeNumber); } \
  NS_SCRIPTABLE NS_IMETHOD SetLastChangeNumber(PRInt32 aLastChangeNumber) { return _to SetLastChangeNumber(aLastChangeNumber); } \
  NS_SCRIPTABLE NS_IMETHOD GetDataVersion(nsACString & aDataVersion) { return _to GetDataVersion(aDataVersion); } \
  NS_SCRIPTABLE NS_IMETHOD SetDataVersion(const nsACString & aDataVersion) { return _to SetDataVersion(aDataVersion); } \
  NS_SCRIPTABLE NS_IMETHOD GetAttributeMap(nsIAbLDAPAttributeMap * *aAttributeMap) { return _to GetAttributeMap(aAttributeMap); } \
  NS_SCRIPTABLE NS_IMETHOD GetLDAPURL(nsILDAPURL * *aLDAPURL) { return _to GetLDAPURL(aLDAPURL); } \
  NS_SCRIPTABLE NS_IMETHOD SetLDAPURL(nsILDAPURL * aLDAPURL) { return _to SetLDAPURL(aLDAPURL); } \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFile(nsILocalFile * *aReplicationFile) { return _to GetReplicationFile(aReplicationFile); } \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationDatabase(nsIAddrDatabase * *aReplicationDatabase) { return _to GetReplicationDatabase(aReplicationDatabase); } \
  NS_SCRIPTABLE NS_IMETHOD GetRdnAttributes(nsACString & aRdnAttributes) { return _to GetRdnAttributes(aRdnAttributes); } \
  NS_SCRIPTABLE NS_IMETHOD SetRdnAttributes(const nsACString & aRdnAttributes) { return _to SetRdnAttributes(aRdnAttributes); } \
  NS_SCRIPTABLE NS_IMETHOD GetObjectClasses(nsACString & aObjectClasses) { return _to GetObjectClasses(aObjectClasses); } \
  NS_SCRIPTABLE NS_IMETHOD SetObjectClasses(const nsACString & aObjectClasses) { return _to SetObjectClasses(aObjectClasses); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIABLDAPDIRECTORY(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetSearchServerControls(nsIMutableArray * *aSearchServerControls) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSearchServerControls(aSearchServerControls); } \
  NS_SCRIPTABLE NS_IMETHOD SetSearchServerControls(nsIMutableArray * aSearchServerControls) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSearchServerControls(aSearchServerControls); } \
  NS_SCRIPTABLE NS_IMETHOD GetSearchClientControls(nsIMutableArray * *aSearchClientControls) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSearchClientControls(aSearchClientControls); } \
  NS_SCRIPTABLE NS_IMETHOD SetSearchClientControls(nsIMutableArray * aSearchClientControls) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSearchClientControls(aSearchClientControls); } \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFileName(nsACString & aReplicationFileName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetReplicationFileName(aReplicationFileName); } \
  NS_SCRIPTABLE NS_IMETHOD SetReplicationFileName(const nsACString & aReplicationFileName) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetReplicationFileName(aReplicationFileName); } \
  NS_SCRIPTABLE NS_IMETHOD GetProtocolVersion(PRUint32 *aProtocolVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetProtocolVersion(aProtocolVersion); } \
  NS_SCRIPTABLE NS_IMETHOD SetProtocolVersion(PRUint32 aProtocolVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetProtocolVersion(aProtocolVersion); } \
  NS_SCRIPTABLE NS_IMETHOD GetSaslMechanism(nsACString & aSaslMechanism) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSaslMechanism(aSaslMechanism); } \
  NS_SCRIPTABLE NS_IMETHOD SetSaslMechanism(const nsACString & aSaslMechanism) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSaslMechanism(aSaslMechanism); } \
  NS_SCRIPTABLE NS_IMETHOD GetAuthDn(nsACString & aAuthDn) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAuthDn(aAuthDn); } \
  NS_SCRIPTABLE NS_IMETHOD SetAuthDn(const nsACString & aAuthDn) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetAuthDn(aAuthDn); } \
  NS_SCRIPTABLE NS_IMETHOD GetMaxHits(PRInt32 *aMaxHits) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMaxHits(aMaxHits); } \
  NS_SCRIPTABLE NS_IMETHOD SetMaxHits(PRInt32 aMaxHits) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetMaxHits(aMaxHits); } \
  NS_SCRIPTABLE NS_IMETHOD GetLastChangeNumber(PRInt32 *aLastChangeNumber) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLastChangeNumber(aLastChangeNumber); } \
  NS_SCRIPTABLE NS_IMETHOD SetLastChangeNumber(PRInt32 aLastChangeNumber) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLastChangeNumber(aLastChangeNumber); } \
  NS_SCRIPTABLE NS_IMETHOD GetDataVersion(nsACString & aDataVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDataVersion(aDataVersion); } \
  NS_SCRIPTABLE NS_IMETHOD SetDataVersion(const nsACString & aDataVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDataVersion(aDataVersion); } \
  NS_SCRIPTABLE NS_IMETHOD GetAttributeMap(nsIAbLDAPAttributeMap * *aAttributeMap) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAttributeMap(aAttributeMap); } \
  NS_SCRIPTABLE NS_IMETHOD GetLDAPURL(nsILDAPURL * *aLDAPURL) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLDAPURL(aLDAPURL); } \
  NS_SCRIPTABLE NS_IMETHOD SetLDAPURL(nsILDAPURL * aLDAPURL) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLDAPURL(aLDAPURL); } \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationFile(nsILocalFile * *aReplicationFile) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetReplicationFile(aReplicationFile); } \
  NS_SCRIPTABLE NS_IMETHOD GetReplicationDatabase(nsIAddrDatabase * *aReplicationDatabase) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetReplicationDatabase(aReplicationDatabase); } \
  NS_SCRIPTABLE NS_IMETHOD GetRdnAttributes(nsACString & aRdnAttributes) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRdnAttributes(aRdnAttributes); } \
  NS_SCRIPTABLE NS_IMETHOD SetRdnAttributes(const nsACString & aRdnAttributes) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRdnAttributes(aRdnAttributes); } \
  NS_SCRIPTABLE NS_IMETHOD GetObjectClasses(nsACString & aObjectClasses) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetObjectClasses(aObjectClasses); } \
  NS_SCRIPTABLE NS_IMETHOD SetObjectClasses(const nsACString & aObjectClasses) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetObjectClasses(aObjectClasses); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsAbLDAPDirectory : public nsIAbLDAPDirectory
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIABLDAPDIRECTORY

  nsAbLDAPDirectory();

private:
  ~nsAbLDAPDirectory();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsAbLDAPDirectory, nsIAbLDAPDirectory)

nsAbLDAPDirectory::nsAbLDAPDirectory()
{
  /* member initializers and constructor code */
}

nsAbLDAPDirectory::~nsAbLDAPDirectory()
{
  /* destructor code */
}

/* attribute nsIMutableArray searchServerControls; */
NS_IMETHODIMP nsAbLDAPDirectory::GetSearchServerControls(nsIMutableArray * *aSearchServerControls)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetSearchServerControls(nsIMutableArray * aSearchServerControls)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIMutableArray searchClientControls; */
NS_IMETHODIMP nsAbLDAPDirectory::GetSearchClientControls(nsIMutableArray * *aSearchClientControls)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetSearchClientControls(nsIMutableArray * aSearchClientControls)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute ACString replicationFileName; */
NS_IMETHODIMP nsAbLDAPDirectory::GetReplicationFileName(nsACString & aReplicationFileName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetReplicationFileName(const nsACString & aReplicationFileName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long protocolVersion; */
NS_IMETHODIMP nsAbLDAPDirectory::GetProtocolVersion(PRUint32 *aProtocolVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetProtocolVersion(PRUint32 aProtocolVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute ACString saslMechanism; */
NS_IMETHODIMP nsAbLDAPDirectory::GetSaslMechanism(nsACString & aSaslMechanism)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetSaslMechanism(const nsACString & aSaslMechanism)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AUTF8String authDn; */
NS_IMETHODIMP nsAbLDAPDirectory::GetAuthDn(nsACString & aAuthDn)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetAuthDn(const nsACString & aAuthDn)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute long maxHits; */
NS_IMETHODIMP nsAbLDAPDirectory::GetMaxHits(PRInt32 *aMaxHits)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetMaxHits(PRInt32 aMaxHits)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute long lastChangeNumber; */
NS_IMETHODIMP nsAbLDAPDirectory::GetLastChangeNumber(PRInt32 *aLastChangeNumber)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetLastChangeNumber(PRInt32 aLastChangeNumber)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute ACString dataVersion; */
NS_IMETHODIMP nsAbLDAPDirectory::GetDataVersion(nsACString & aDataVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetDataVersion(const nsACString & aDataVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIAbLDAPAttributeMap attributeMap; */
NS_IMETHODIMP nsAbLDAPDirectory::GetAttributeMap(nsIAbLDAPAttributeMap * *aAttributeMap)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsILDAPURL lDAPURL; */
NS_IMETHODIMP nsAbLDAPDirectory::GetLDAPURL(nsILDAPURL * *aLDAPURL)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetLDAPURL(nsILDAPURL * aLDAPURL)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsILocalFile replicationFile; */
NS_IMETHODIMP nsAbLDAPDirectory::GetReplicationFile(nsILocalFile * *aReplicationFile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIAddrDatabase replicationDatabase; */
NS_IMETHODIMP nsAbLDAPDirectory::GetReplicationDatabase(nsIAddrDatabase * *aReplicationDatabase)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute ACString rdnAttributes; */
NS_IMETHODIMP nsAbLDAPDirectory::GetRdnAttributes(nsACString & aRdnAttributes)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetRdnAttributes(const nsACString & aRdnAttributes)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute ACString objectClasses; */
NS_IMETHODIMP nsAbLDAPDirectory::GetObjectClasses(nsACString & aObjectClasses)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAbLDAPDirectory::SetObjectClasses(const nsACString & aObjectClasses)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIAbLDAPDirectory_h__ */
