/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /builddir/build/BUILD/thunderbird-3.0.5/comm-1.9.1/mail/components/migration/public/nsIMailProfileMigrator.idl
 */

#ifndef __gen_nsIMailProfileMigrator_h__
#define __gen_nsIMailProfileMigrator_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIArray; /* forward declaration */

class nsIProfileStartup; /* forward declaration */


/* starting interface:    nsIMailProfileMigrator */
#define NS_IMAILPROFILEMIGRATOR_IID_STR "fca38a7a-c43f-4b28-adbd-61e5cc942508"

#define NS_IMAILPROFILEMIGRATOR_IID \
  {0xfca38a7a, 0xc43f, 0x4b28, \
    { 0xad, 0xbd, 0x61, 0xe5, 0xcc, 0x94, 0x25, 0x08 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIMailProfileMigrator : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IMAILPROFILEMIGRATOR_IID)

  /**
   * profile items to migrate. use with migrate().
   */
  enum { ALL = 0U };

  enum { SETTINGS = 1U };

  enum { ACCOUNT_SETTINGS = 2U };

  enum { ADDRESSBOOK_DATA = 4U };

  enum { JUNKTRAINING = 8U };

  enum { PASSWORDS = 16U };

  enum { OTHERDATA = 32U };

  enum { NEWSDATA = 64U };

  enum { MAILDATA = 128U };

  enum { FILTERS = 256U };

  /**
   * Copy user profile information to the current active profile.
   * @param aItems   list of data items to migrate. see above for values.
   * @param aReplace replace or append current data where applicable.
   * @param aProfile profile to migrate from, if there is more than one.
   */
  /* void migrate (in unsigned short aItems, in nsIProfileStartup aStartup, in wstring aProfile); */
  NS_SCRIPTABLE NS_IMETHOD Migrate(PRUint16 aItems, nsIProfileStartup *aStartup, const PRUnichar *aProfile) = 0;

  /**
   * A bit field containing profile items that this migrator
   * offers for import.
   * @param   aProfile the profile that we are looking for available data
   *          to import
   * @param   aStarting "true" if the profile is not currently being used.
   * @returns bit field containing profile items (see above)
   */
  /* unsigned short getMigrateData (in wstring aProfile, in boolean aDoingStartup); */
  NS_SCRIPTABLE NS_IMETHOD GetMigrateData(const PRUnichar *aProfile, PRBool aDoingStartup, PRUint16 *_retval NS_OUTPARAM) = 0;

  /**
   * Whether or not there is any data that can be imported from this
   * browser (i.e. whether or not it is installed, and there exists
   * a user profile)
   */
  /* readonly attribute boolean sourceExists; */
  NS_SCRIPTABLE NS_IMETHOD GetSourceExists(PRBool *aSourceExists) = 0;

  /**
   * Whether or not the import source implementing this interface
   * has multiple user profiles configured.
   */
  /* readonly attribute boolean sourceHasMultipleProfiles; */
  NS_SCRIPTABLE NS_IMETHOD GetSourceHasMultipleProfiles(PRBool *aSourceHasMultipleProfiles) = 0;

  /**
   * An enumeration of available profiles. If the import source does
   * not support profiles, this attribute is null.
   */
  /* readonly attribute nsIArray sourceProfiles; */
  NS_SCRIPTABLE NS_IMETHOD GetSourceProfiles(nsIArray * *aSourceProfiles) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIMailProfileMigrator, NS_IMAILPROFILEMIGRATOR_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMAILPROFILEMIGRATOR \
  NS_SCRIPTABLE NS_IMETHOD Migrate(PRUint16 aItems, nsIProfileStartup *aStartup, const PRUnichar *aProfile); \
  NS_SCRIPTABLE NS_IMETHOD GetMigrateData(const PRUnichar *aProfile, PRBool aDoingStartup, PRUint16 *_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetSourceExists(PRBool *aSourceExists); \
  NS_SCRIPTABLE NS_IMETHOD GetSourceHasMultipleProfiles(PRBool *aSourceHasMultipleProfiles); \
  NS_SCRIPTABLE NS_IMETHOD GetSourceProfiles(nsIArray * *aSourceProfiles); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMAILPROFILEMIGRATOR(_to) \
  NS_SCRIPTABLE NS_IMETHOD Migrate(PRUint16 aItems, nsIProfileStartup *aStartup, const PRUnichar *aProfile) { return _to Migrate(aItems, aStartup, aProfile); } \
  NS_SCRIPTABLE NS_IMETHOD GetMigrateData(const PRUnichar *aProfile, PRBool aDoingStartup, PRUint16 *_retval NS_OUTPARAM) { return _to GetMigrateData(aProfile, aDoingStartup, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetSourceExists(PRBool *aSourceExists) { return _to GetSourceExists(aSourceExists); } \
  NS_SCRIPTABLE NS_IMETHOD GetSourceHasMultipleProfiles(PRBool *aSourceHasMultipleProfiles) { return _to GetSourceHasMultipleProfiles(aSourceHasMultipleProfiles); } \
  NS_SCRIPTABLE NS_IMETHOD GetSourceProfiles(nsIArray * *aSourceProfiles) { return _to GetSourceProfiles(aSourceProfiles); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIMAILPROFILEMIGRATOR(_to) \
  NS_SCRIPTABLE NS_IMETHOD Migrate(PRUint16 aItems, nsIProfileStartup *aStartup, const PRUnichar *aProfile) { return !_to ? NS_ERROR_NULL_POINTER : _to->Migrate(aItems, aStartup, aProfile); } \
  NS_SCRIPTABLE NS_IMETHOD GetMigrateData(const PRUnichar *aProfile, PRBool aDoingStartup, PRUint16 *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMigrateData(aProfile, aDoingStartup, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetSourceExists(PRBool *aSourceExists) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSourceExists(aSourceExists); } \
  NS_SCRIPTABLE NS_IMETHOD GetSourceHasMultipleProfiles(PRBool *aSourceHasMultipleProfiles) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSourceHasMultipleProfiles(aSourceHasMultipleProfiles); } \
  NS_SCRIPTABLE NS_IMETHOD GetSourceProfiles(nsIArray * *aSourceProfiles) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSourceProfiles(aSourceProfiles); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsMailProfileMigrator : public nsIMailProfileMigrator
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMAILPROFILEMIGRATOR

  nsMailProfileMigrator();

private:
  ~nsMailProfileMigrator();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsMailProfileMigrator, nsIMailProfileMigrator)

nsMailProfileMigrator::nsMailProfileMigrator()
{
  /* member initializers and constructor code */
}

nsMailProfileMigrator::~nsMailProfileMigrator()
{
  /* destructor code */
}

/* void migrate (in unsigned short aItems, in nsIProfileStartup aStartup, in wstring aProfile); */
NS_IMETHODIMP nsMailProfileMigrator::Migrate(PRUint16 aItems, nsIProfileStartup *aStartup, const PRUnichar *aProfile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* unsigned short getMigrateData (in wstring aProfile, in boolean aDoingStartup); */
NS_IMETHODIMP nsMailProfileMigrator::GetMigrateData(const PRUnichar *aProfile, PRBool aDoingStartup, PRUint16 *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean sourceExists; */
NS_IMETHODIMP nsMailProfileMigrator::GetSourceExists(PRBool *aSourceExists)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean sourceHasMultipleProfiles; */
NS_IMETHODIMP nsMailProfileMigrator::GetSourceHasMultipleProfiles(PRBool *aSourceHasMultipleProfiles)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIArray sourceProfiles; */
NS_IMETHODIMP nsMailProfileMigrator::GetSourceProfiles(nsIArray * *aSourceProfiles)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIMailProfileMigrator_h__ */
